module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/home/paul/doc/dev/NodeJS/botpress-irc";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(1);


/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	var _config = __webpack_require__(2);
	
	var _config2 = _interopRequireDefault(_config);
	
	var _lodash = __webpack_require__(3);
	
	var _lodash2 = _interopRequireDefault(_lodash);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	var irc = __webpack_require__(7);
	var outgoing = __webpack_require__(8);
	var incoming = __webpack_require__(9);
	var actions = __webpack_require__(10);
	var Promise = __webpack_require__(11);
	
	
	var client = null;
	var outgoingPending = outgoing.pending;
	
	var outgoingMiddleware = function outgoingMiddleware(event, next) {
	  if (event.platform !== "irc") {
	    return next();
	  }
	  if (!outgoing[event.type]) {
	    return next("Unsupported event type: " + event.type);
	  }
	
	  outgoing[event.type](event, next, client);
	};
	
	module.exports = {
	  init: function init(bp) {
	
	    bp.middlewares.register({
	      name: "irc.sendMessages",
	      type: "outgoing",
	      order: 100,
	      handler: outgoingMiddleware,
	      module: "botpress-irc",
	      description: "Sends out messages that targets platform = slack." + " This middleware should be placed at the end as it swallows events once sent."
	    });
	
	    bp.irc = {};
	    _lodash2.default.forIn(actions, function (action, name) {
	      bp.irc[name] = action;
	      var sendName = name.replace(/^create/, "send");
	      bp.irc[sendName] = Promise.method(function () {
	        var msg = action.apply(this, arguments);
	        msg.__id = new Date().toISOString() + Math.random();
	        var resolver = { event: msg };
	        var promise = new Promise(function (resolve, reject) {
	          resolver.resolve = resolve;
	          resolver.reject = reject;
	        });
	        outgoingPending[msg.__id] = resolver;
	        bp.middlewares.sendOutgoing(msg);
	        return promise;
	      });
	    });
	  },
	  ready: function ready(bp) {
	    var config = (0, _config2.default)(bp);
	    client = new irc.Client(config.server.get(), config.nick.get(), {
	      channels: config.channels.get()
	    });
	    incoming(bp, client);
	  }
	};

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	var _lodash = __webpack_require__(3);
	
	var _lodash2 = _interopRequireDefault(_lodash);
	
	var _storage = __webpack_require__(4);
	
	var _storage2 = _interopRequireDefault(_storage);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
	
	exports.default = function (bp) {
	  var configKeys = ["server", "nick", "channels"];
	
	  var configDefaults = {
	    server: "irc.freenode.net",
	    nick: "Botpress",
	    channels: []
	  };
	
	  var configStorage = (0, _storage2.default)(bp, configDefaults);
	
	  var config = configStorage.load();
	
	  var createConfigAccessMethods = function createConfigAccessMethods(key) {
	    return {
	      get: function get() {
	        return config[key];
	      },
	      set: function set(value) {
	        config[key] = value;
	        configStorage.save(config);
	      }
	    };
	  };
	
	  var accessMethods = _lodash2.default.reduce(configKeys, function (acc, key) {
	    return _extends({}, acc, _defineProperty({}, key, createConfigAccessMethods(key)));
	  }, {});
	
	  var extraMethods = {
	    getAll: function getAll() {
	      return config;
	    },
	    setAll: function setAll(newConfig) {
	      return _lodash2.default.forEach(configKeys, function (key) {
	        accessMethods[key].set(newConfig[key]);
	      });
	    }
	  };
	
	  return _extends({}, accessMethods, extraMethods);
	};

/***/ },
/* 3 */
/***/ function(module, exports) {

	module.exports = require("lodash");

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _lodash = __webpack_require__(3);
	
	var _lodash2 = _interopRequireDefault(_lodash);
	
	var _path = __webpack_require__(5);
	
	var _path2 = _interopRequireDefault(_path);
	
	var _fs = __webpack_require__(6);
	
	var _fs2 = _interopRequireDefault(_fs);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	var getFilePath = function getFilePath(bp, name) {
	  var projectLocation = bp.projectLocation,
	      modulesConfigDir = bp.botfile.modulesConfigDir;
	
	
	  var fileName = name ? 'botpress-irc-' + name + '.json' : 'botpress-irc.json';
	
	  return _path2.default.join(projectLocation, modulesConfigDir, fileName);
	};
	
	var writeJsonFile = function writeJsonFile(filePath, data) {
	  return _fs2.default.writeFileSync(filePath, JSON.stringify(data));
	};
	
	var readJsonFile = _lodash2.default.flow([_fs2.default.readFileSync, JSON.parse]);
	
	var createSaveFn = function createSaveFn(filePath) {
	  return function (data) {
	    return writeJsonFile(filePath, data);
	  };
	};
	
	var createLoadFn = function createLoadFn(filePath, defaultData) {
	  return function () {
	    if (!_fs2.default.existsSync(filePath)) {
	      createSaveFn(filePath)(defaultData);
	      return defaultData;
	    }
	
	    return readJsonFile(filePath);
	  };
	};
	
	exports.default = function (bp, defaultData, name) {
	  var filePath = getFilePath(bp, name);
	
	  return {
	    save: createSaveFn(filePath),
	    load: createLoadFn(filePath, defaultData)
	  };
	};

/***/ },
/* 5 */
/***/ function(module, exports) {

	module.exports = require("path");

/***/ },
/* 6 */
/***/ function(module, exports) {

	module.exports = require("fs");

/***/ },
/* 7 */
/***/ function(module, exports) {

	module.exports = require("irc");

/***/ },
/* 8 */
/***/ function(module, exports) {

	"use strict";
	
	var handlePromise = function handlePromise(next, promise) {
	  return promise.then(function (res) {
	    next();
	    return res;
	  }).catch(function (err) {
	    next(err);
	    throw err;
	  });
	};
	
	var handleMessage = function handleMessage(event, next, irc) {
	  if (event.platform !== "irc" || event.type !== "message") {
	    return next();
	  }
	  var channel = event.raw.to;
	  var text = event.text;
	  irc.say(channel, text);
	  next();
	};
	
	module.exports = {
	  "message": handleMessage,
	  "pm": handleMessage,
	  pending: {}
	};

/***/ },
/* 9 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	var _outgoing = __webpack_require__(8);
	
	var _outgoing2 = _interopRequireDefault(_outgoing);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	module.exports = function (bp, irc) {
	  irc.addListener("message", function (from, to, message) {
	    if (to === irc.nick) {
	      bp.middlewares.sendIncoming({
	        platform: "irc",
	        type: "pm",
	        user: from,
	        text: message,
	        raw: {
	          from: from,
	          message: message
	        }
	      });
	    } else {
	      bp.middlewares.sendIncoming({
	        platform: "irc",
	        type: "message",
	        user: from,
	        channel: to,
	        text: message,
	        raw: {}
	      });
	    }
	  });
	  /*irc.addListener("pm", function(from, message) {
	  bp.middlewares.sendIncoming({
	      platform: "irc",
	      type: "pm",
	      user: from,
	      text: message,
	      raw: {
	        from: from,
	        message: message
	      }
	    })
	  })*/
	};

/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	"use strict";
	
	var _lodash = __webpack_require__(3);
	
	var _lodash2 = _interopRequireDefault(_lodash);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	var createMessage = function createMessage(channel, txt) {
	  return {
	    platform: "irc",
	    type: "message",
	    text: txt,
	    raw: {
	      to: channel
	    }
	  };
	};
	
	module.exports = {
	  createMessage: createMessage
	};

/***/ },
/* 11 */
/***/ function(module, exports) {

	module.exports = require("bluebird");

/***/ }
/******/ ]);
//# sourceMappingURL=node.bundle.js.map